<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelSettingInput ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelSettingInput extends AbstractStructArrayBase
{
    /**
     * The PanelSettingInput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\PanelSettingInput[]
     */
    public $PanelSettingInput;
    /**
     * Constructor method for ArrayOfPanelSettingInput
     * @uses ArrayOfPanelSettingInput::setPanelSettingInput()
     * @param \CustomerManagement\StructType\PanelSettingInput[] $panelSettingInput
     */
    public function __construct(array $panelSettingInput = array())
    {
        $this
            ->setPanelSettingInput($panelSettingInput);
    }
    /**
     * Get PanelSettingInput value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\PanelSettingInput[]|null
     */
    public function getPanelSettingInput()
    {
        return isset($this->PanelSettingInput) ? $this->PanelSettingInput : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelSettingInput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelSettingInput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelSettingInputForArrayConstraintsFromSetPanelSettingInput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelSettingInputPanelSettingInputItem) {
            // validation for constraint: itemType
            if (!$arrayOfPanelSettingInputPanelSettingInputItem instanceof \CustomerManagement\StructType\PanelSettingInput) {
                $invalidValues[] = is_object($arrayOfPanelSettingInputPanelSettingInputItem) ? get_class($arrayOfPanelSettingInputPanelSettingInputItem) : sprintf('%s(%s)', gettype($arrayOfPanelSettingInputPanelSettingInputItem), var_export($arrayOfPanelSettingInputPanelSettingInputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PanelSettingInput property can only contain items of type \CustomerManagement\StructType\PanelSettingInput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelSettingInput value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingInput[] $panelSettingInput
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingInput
     */
    public function setPanelSettingInput(array $panelSettingInput = array())
    {
        // validation for constraint: array
        if ('' !== ($panelSettingInputArrayErrorMessage = self::validatePanelSettingInputForArrayConstraintsFromSetPanelSettingInput($panelSettingInput))) {
            throw new \InvalidArgumentException($panelSettingInputArrayErrorMessage, __LINE__);
        }
        if (is_null($panelSettingInput) || (is_array($panelSettingInput) && empty($panelSettingInput))) {
            unset($this->PanelSettingInput);
        } else {
            $this->PanelSettingInput = $panelSettingInput;
        }
        return $this;
    }
    /**
     * Add item to PanelSettingInput value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingInput $item
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingInput
     */
    public function addToPanelSettingInput(\CustomerManagement\StructType\PanelSettingInput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\PanelSettingInput) {
            throw new \InvalidArgumentException(sprintf('The PanelSettingInput property can only contain items of type \CustomerManagement\StructType\PanelSettingInput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PanelSettingInput[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\PanelSettingInput|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\PanelSettingInput|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\PanelSettingInput|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\PanelSettingInput|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\PanelSettingInput|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelSettingInput
     */
    public function getAttributeName()
    {
        return 'PanelSettingInput';
    }
}
